# devkitPro Docker Development Containers

devkitPro is a collection of different toolchains created for developing homebrew for home consoles, most notably for Nintendo consoles. They are fairly robust, however the only supported method is to use their Pacman (Arch Linux) repositories, requiring the installation of Pacman for other Linux distributions and operating systems.

This repo hopes to create a development environment that is usable for developing homebrew on other systems without needing to install Pacman to their system. I feel that needing to install a package manager other than the one your system ships with makes things more complicated and can confuse your current package manager, so having an isolated environment will solve that problem and allow people to use fairly vanilla systems.

**THIS REPO IS NOT OFFICIALLY SUPPORTED BY DEVKITPRO AND SHOULD NOT BE CONSIDERED AN OFFICIAL OUTLET TO USE THE TOOLCHAINS PROVIDED BY DEVKITPRO.**

## How to use

1. Install [Docker](https://docs.docker.com/engine/install/) and [Git](https://git-scm.com/) using your package manager or by downloading them manually.
  1. Windows and macOS users may want to install [Docker Desktop](https://www.docker.com/products/docker-desktop/) instead.
1. Clone this repository and enter it.
    ```sh
    git clone https://git.brysonsteck.xyz/brysonsteck/devkitPro.git && cd devkitPro
    ```
1. Run this command to build a Docker image for the tools you need. For a list of package names, see the section "Unix-like platforms" on the [devkitPro Wiki](https://devkitpro.org/wiki/Getting_Started#Unix-like_platforms).
    ```sh
    docker build -t devkitpro --build-arg TOOLS="wii-dev" .
    ```
1. Create and start a container from this new image. The work directory is set to `/volume`, so it's recommended to mount your project's directory to that location.
    ```sh
    docker container create --name devkitpro-container -v /path/to/project:/volume devkitPro
    docker container start devkitpro-container
    ```
1. You can now access this container using `docker exec`. This image is based off of `archlinux`, so you have the ability to run a shell.
    ```sh
    $ docker exec -it devkitpro-container bash
    [devkitpro@d41c71ef5898 volume]$
    ```
1. To stop the container, run this command on the host:
    ```sh
    docker container stop devkitpro-container
    ```

